#include <stdlib.h>
#include <stdio.h>
#include <assert.h>
#include "double_linked.h"

typedef struct maillon maillon;
struct maillon
{
  int val;
  maillon *suiv;
  maillon *prec;
};

struct file
{
  maillon *fictif_d;
  maillon *fictif_f;
};
typedef struct file file;

file *creer_file()
{
  file *f = (file *)malloc(sizeof(file));
  maillon *debut = (maillon *)malloc(sizeof(maillon));
  maillon *fin = (maillon *)malloc(sizeof(maillon));
  debut->suiv = fin;
  debut->prec = NULL;
  fin->suiv = NULL;
  fin->prec = debut;
  f->fictif_d = debut;
  f->fictif_f = fin;
  return f;
}

bool file_est_vide(file *f)
{
  return f->fictif_d->suiv == f->fictif_f;
}

void enfiler(file *f, int x)
{
  maillon *m = (maillon *)malloc(sizeof(maillon));
  m->val = x;
  m->suiv = f->fictif_d->suiv;
  m->prec = f->fictif_d;
  f->fictif_d->suiv = m;
  m->suiv->prec = m;
}

int defiler(file *f)
{
  assert(!file_est_vide(f));
  maillon *m = f->fictif_f->prec;
  int x = m->val;
  f->fictif_f->prec = m->prec;
  m->prec->suiv = f->fictif_f;
  free(m);
  return x;
}

void detruire_file(file *f)
{
  while (!file_est_vide(f))
  {
    defiler(f);
  }
  free(f->fictif_d);
  free(f->fictif_f);
  free(f);
}
