#include <stdlib.h>
#include <stdio.h>
#include <assert.h>
#include "liste_python.h"

struct liste
{
  int *tab;
  int n_max;
  int longueur;
};
typedef struct liste liste;

liste *creer_liste()
{
  liste *L = (liste *)malloc(sizeof(liste));
  L->n_max = 1;
  L->tab = (int *)malloc(L->n_max * sizeof(int));
  L->longueur = 0;
  return L;
}

bool liste_est_vide(liste *L)
{
  return L->longueur == 0;
}

int longueur(liste *L)
{
  return L->longueur;
}

void append(liste *L, int x)
{
  if (L->longueur == L->n_max)
  {
    L->n_max = 2 * L->n_max + 1;
    int *new_tab = (int *)malloc(L->n_max * sizeof(int));
    for (int i = 0; i < L->longueur; i++)
    {
      new_tab[i] = L->tab[i];
    }
    free(L->tab);
    L->tab = new_tab;
  }
  L->longueur++;
  L->tab[L->longueur - 1] = x;
}

int pop(liste *L)
{
  assert(!liste_est_vide(L));
  int x = L->tab[L->longueur - 1];
  L->longueur--;
  return x;
}

void modifier(liste *L, int i, int x)
{
  assert(i < L->longueur);
  L->tab[i] = x;
}

int valeur(liste *L, int i)
{
  assert(i < L->longueur);
  return L->tab[i];
}

void detruire_liste(liste *L)
{
  free(L->tab);
  free(L);
}
