#include <stdlib.h>
#include <stdio.h>
#include <assert.h>
#include "liste.h"

struct maillon {
  int val;
  liste suivant;
};

liste creer_liste()
{
  liste l = (liste)malloc(sizeof(maillon));
  l->suivant = NULL;
  return l;
}

bool liste_est_vide(liste l)
{
  return l->suivant == NULL;
}

int liste_tete(liste l)
{
  assert(l->suivant != NULL);
  return l->suivant->val;
}

liste liste_suivant(liste l)
{
  return l->suivant;
}

void liste_insertion(liste l, int val)
{
  maillon *m = (maillon *) malloc(sizeof(maillon));
  m->val = val;
  m->suivant = l->suivant;
  l->suivant = m;
}

void liste_suppression(liste l)
{
  assert(l->suivant != NULL);
  liste s = l->suivant;
  l->suivant = s->suivant;
  free(s);
}

void detruire_liste(liste l)
{
  while (!liste_est_vide(l))
  {
    liste_suppression(l);
  }
  free(l);
}

