#include <stdlib.h>
#include <stdio.h>
#include <assert.h>
#include "liste_python.h"

typedef struct maillon maillon;
struct maillon
{
  int val;
  maillon *suiv;
  maillon *prec;
};

struct liste
{
  maillon *fictif_d;
  maillon *fictif_f;
  int longueur;
};
typedef struct liste liste;

liste *creer_liste()
{
  liste *L = (liste *)malloc(sizeof(liste));
  maillon *debut = (maillon *)malloc(sizeof(maillon));
  maillon *fin = (maillon *)malloc(sizeof(maillon));
  debut->suiv = fin;
  debut->prec = NULL;
  fin->suiv = NULL;
  fin->prec = debut;
  L->fictif_d = debut;
  L->fictif_f = fin;
  L->longueur = 0;
  return L;
}

bool liste_est_vide(liste *L)
{
  return L->longueur == 0;
}

int longueur(liste *L)
{
  return L->longueur;
}

void append(liste *L, int x)
{
  maillon *m = (maillon *)malloc(sizeof(maillon));
  m->val = x;
  m->suiv = L->fictif_f;
  m->prec = L->fictif_f->prec;
  L->fictif_f->prec = m;
  m->prec->suiv = m;
  L->longueur++;
}

int pop(liste *L)
{
  assert(!liste_est_vide(L));
  maillon *m = L->fictif_f->prec;
  int x = m->val;
  L->fictif_f->prec = m->prec;
  m->prec->suiv = L->fictif_f;
  free(m);
  L->longueur--;
  return x;
}

/* renvoie un pointeur 
   vers le i-ème maillon
  de la liste L */ 
maillon *trouver(liste *L, int i)
{
  assert(i < L->longueur);
  maillon *m = L->fictif_d->suiv;
  for (int j = 0; j < i; j++)
  { /* m pointe vers le j-ème maillon de la liste */
    m = m->suiv;
  }
  return m;
}

void modifier(liste *L, int i, int x)
{
  maillon *m = trouver(L, i);
  m->val = x;
}

int valeur(liste *L, int i)
{
  maillon *m = trouver(L, i);
  return m->val;
}

void detruire_liste(liste *L)
{
  while (!liste_est_vide(L))
  {
    pop(L);
  }
  free(L->fictif_d);
  free(L->fictif_f);
  free(L);
}
