#include <stdlib.h>
#include <stdio.h>
#include <assert.h>
#include "pile.h"

struct maillon {
  int val;
  pile suivant;
};

pile creer_pile()
{
  pile p = (pile)malloc(sizeof(maillon));
  p->suivant = NULL;
  return p;
}

bool pile_est_vide(pile p)
{
  return p->suivant == NULL;
}

int sommet(pile p)
{
  assert(p->suivant != NULL);
  return p->suivant->val;
}

pile pile_suivant(pile p)
{
  return p->suivant;
}

void empiler(pile p, int x)
{
  maillon *m = (maillon *) malloc(sizeof(maillon));
  m->val = x;
  m->suivant = p->suivant;
  p->suivant = m;
}

int depiler(pile p)
{
  assert(p->suivant != NULL);
  pile s = p->suivant;
  p->suivant = s->suivant;
  int val = s->val;
  free(s);
  return val;
}

void detruire_pile(pile p)
{
  while (!pile_est_vide(p))
  {
    depiler(p);
  }
  free(p);
}

