#include <stdlib.h>
#include <stdbool.h>
#include <assert.h>

struct pile
{
  int *contenu;
  int nb;
  int capacite;
};
typedef struct pile pile;

pile creer_pile(int c)
{
  pile p;
  p.contenu = (int *)malloc(c * sizeof(int));
  p.nb = 0;
  p.capacite = c;
  return p;
}

bool pile_vide(pile p)
{
  return (p.nb == 0);
}

int sommet(pile p)
{
  assert(!pile_vide(p));
  return p.contenu[p.nb-1];
}

int depiler(pile *p)
{
  assert(!pile_vide(*p));
  p->nb--;
  return p->contenu[p->nb];
}

void empiler(pile *p, int x)
{
  assert(p->nb < p->capacite);
  p->nb++;
  p->contenu[p->nb-1] = x;
}

void detruire_pile(pile p)
{
  free(p.contenu);
}
